VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "WinHelp"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

Option Explicit

'System constants
Private Const HELP_CONTEXT = &H1
Private Const HELP_QUIT = &H2
Private Const HELP_INDEX = &H3
Private Const HELP_CONTENTS = &H3&
Private Const HELP_HELPONHELP = &H4
Private Const HELP_SETINDEX = &H5
Private Const HELP_SETCONTENTS = &H5&
Private Const HELP_CONTEXTPOPUP = &H8&
Private Const HELP_FORCEFILE = &H9&
Private Const HELP_KEY = &H101
Private Const HELP_COMMAND = &H102&
Private Const HELP_PARTIALKEY = &H105&
Private Const HELP_MULTIKEY = &H201&
Private Const HELP_SETWINPOS = &H203&
Private Const HELP_FINDER = &HB

'Private class data
Private HelpFile As String
Private Hwnd As Long

'Declaration for WinHelp API
Private Declare Function WinHelpKey Lib "user32" Alias "WinHelpA" (ByVal hwnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As String) As Long
Private Declare Function WinHelp Lib "user32" Alias "WinHelpA" (ByVal hwnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Long) As Long

Public Sub ShowKeyList(Key As String)
    Dim RetVal As Long
    Dim Scratch As String
    Scratch = "AL(`" & sKey & "', 1, `', `')" & Chr$(0)
    If (Hwnd <> 0) And (HelpFile <> "") Then
        RetVal = WinHelpKey(Hwnd, HelpFile, HELP_COMMAND, Scratch)
    End If
End Sub

Public Sub ShowContents()
    Dim RetVal As Long
    If (Hwnd <> 0) And (HelpFile <> "") Then
        RetVal = WinHelp(Hwnd, HelpFile, HELP_FINDER, 0&)
    End If
End Sub

Public Sub ShowPopup(lContext As Long)
    Dim RetVal As Long
    If (Hwnd <> 0) And (HelpFile <> "") Then
        RetVal = WinHelp(Hwnd, HelpFile, HELP_CONTEXTPOPUP, lContext)
    End If
End Sub

Public Function SetHelpInfo(lHwnd As Long, sHelpFile As String) As Boolean
    If Dir$(sHelpFile, vbNormal) = "" Then
        SetDefaults = False
        Exit Function
    End If
    Hwnd = lHwnd
    HelpFile = sHelpFile
    SetDefaults = True
End Function

Public Sub ShowTopic(lContext As Long)
    Dim RetVal As Long
    If (Hwnd <> 0) And (HelpFile <> "") Then
        RetVal = WinHelp(Hwnd, HelpFile, HELP_CONTEXT, lContext)
    End If
End Sub

Private Sub Class_Initialize()
    HelpFile = ""
    Hwnd = 0
End Sub

Private Sub Class_Terminate()
    Dim RetVal As Long
    If (Hwnd <> 0) And (HelpFile <> "") Then
        RetVal = WinHelp(Hwnd, HelpFile, HELP_QUIT, 0&)
    End If
End Sub


